using Amazon;
using Amazon.S3;
using Amazon.S3.IO;
using Amazon.S3.Model;
using Amazon.S3.Transfer;
using Microsoft.AspNetCore.Http;

using System.IO;
using System.Threading.Tasks;

namespace AWS
{
    public class S3
    {
        string bucketName = Config.bucketName;
        string accessKey = Config.accessKey;
        string secret = Config.secret;


        public async Task Upload(IFormFile file)
        {
            // access key id and secret key id, can be generated by navigating to IAM roles in AWS and then add new user, select permissions
            //for this example, try giving S3 full permissions
            using (var client = new AmazonS3Client(accessKey, this.secret, RegionEndpoint.EUCentral1))
            {
                using (var newMemoryStream = new MemoryStream())
                {
                    file.CopyTo(newMemoryStream);

                    var uploadRequest = new TransferUtilityUploadRequest
                    {
                        InputStream = newMemoryStream,
                        Key = file.FileName, // filename
                        BucketName = this.bucketName // bucket name of S3
                    };

                    var fileTransferUtility = new TransferUtility(client);
                    await fileTransferUtility.UploadAsync(uploadRequest);
                }
            }
        }

        public async Task Download(string filePath, string fileName, string destination)
        {
            var client = new AmazonS3Client(accessKey, secret, Amazon.RegionEndpoint.EUCentral1);
            var fileTransferUtility = new TransferUtility(client);

            var request = new TransferUtilityDownloadRequest
            {
                BucketName = bucketName,
                FilePath = Path.Combine(filePath, fileName),
                Key = destination + fileName,
            };

            await fileTransferUtility.DownloadAsync(request);

        }

        public string ReadFile(string filePath)
        {
            var client = new AmazonS3Client(accessKey, secret, Amazon.RegionEndpoint.EUCentral1);

            TransferUtility utility = new TransferUtility(client);
            Stream stream = utility.OpenStream(bucketName, filePath);

            System.IO.StreamReader reader = new System.IO.StreamReader(stream);
            string result = reader.ReadToEnd();

            reader.Close();
            stream.Close();
            return result;
        }


        public Task UploadObjectFromContentAsync(
        IAmazonS3 client,
        string bucketName,
        string objectName,
        string content)
        {
            var putRequest = new PutObjectRequest
            {
                BucketName = bucketName,
                Key = objectName,
                ContentBody = content,
            };

            return client.PutObjectAsync(putRequest);
        }

        public Task WriteFile(string filePath, string file)
        {
            var client = new AmazonS3Client(accessKey, secret, Amazon.RegionEndpoint.EUCentral1);

            var putRequest = new PutObjectRequest
            {
                BucketName = bucketName,
                Key = filePath,
                ContentBody = file,
                CannedACL = S3CannedACL.PublicRead
            };

            return client.PutObjectAsync(putRequest);
        }
    }
}
